/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.SeguroKm;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTaxaEmbarqueOrgao;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaSeguroKmController")
@Scope("prototype")
public class BusquedaSeguroKmController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<OrgaoConcedente> plwOrgao;
    private MyListbox seguroKmList;
    private Paging pagingSeguroKm;
    private Textbox txtOrgao;

    public Paging getPagingSeguroKm() {
        return pagingSeguroKm;
    }

    public void setPagingSeguroKm(Paging pagingSeguroKm) {
        this.pagingSeguroKm = pagingSeguroKm;
    }

    public PagedListWrapper<OrgaoConcedente> getPlwOrgao() {
        return plwOrgao;
    }

    public void setPlwOrgao(PagedListWrapper<OrgaoConcedente> plwOrgao) {
        this.plwOrgao = plwOrgao;
    }

    public MyListbox getSeguroKmList() {
        return seguroKmList;
    }

    public void setSeguroKmList(MyListbox seguroKmList) {
        this.seguroKmList = seguroKmList;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        seguroKmList.setItemRenderer(new RenderTaxaEmbarqueOrgao());
        seguroKmList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                OrgaoConcedente c = (OrgaoConcedente) seguroKmList.getSelected();
                verSeguroKm(c);
            }
        });

        refreshLista();

        txtOrgao.focus();
    }

    private void verSeguroKm(OrgaoConcedente o) {
        if (o == null) {
            return;
        }

        Map args = new HashMap();
        args.put("orgao", o);
       // args.put("seguroKm", null);
        args.put("seguroKmList", seguroKmList);

        openWindow("/gui/tarifas/editarSeguroKm.zul",
                Labels.getLabel("busquedaSeguroKmController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {

        HibernateSearchObject<OrgaoConcedente> seguroKmBusqueda =
                new HibernateSearchObject<OrgaoConcedente>(OrgaoConcedente.class,
                pagingSeguroKm.getPageSize());



        seguroKmBusqueda.addFilterEqual("activo", Boolean.TRUE);

        if (!txtOrgao.getValue().equals("")) {
            seguroKmBusqueda.addFilterLike("descOrgao",
                    "%" + txtOrgao.getText().trim().concat("%"));
        }

        seguroKmBusqueda.addSortAsc("descOrgao");


        plwOrgao.init(seguroKmBusqueda, seguroKmList, pagingSeguroKm);

        if (seguroKmList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaSeguroKmController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verSeguroKm(new SeguroKm());
    }

       private void verSeguroKm(SeguroKm tx) {
        if (tx == null) {
            return;
        }

        Map args = new HashMap();
        args.put("orgao", null);
        args.put("seguroKm", tx);
        args.put("seguroKmList", seguroKmList);

        openWindow("/gui/tarifas/editarSeguroKm.zul",
                Labels.getLabel("busquedaSeguroKmController.window.title"),
                args, MODAL);
    }
}
